import { IPublicModelPluginContext } from '@alilc/lowcode-types';
import TreeNode from './tree-node';
import { Tree } from './tree';
export interface ITreeBoard {
    readonly at: string | symbol;
    scrollToNode(treeNode: TreeNode, detail?: any): void;
}
export declare class TreeMaster {
    readonly pluginContext: IPublicModelPluginContext;
    private boards;
    private treeMap;
    constructor(pluginContext: IPublicModelPluginContext);
    private toVision;
    addBoard(board: ITreeBoard): void;
    removeBoard(board: ITreeBoard): void;
    purge(): void;
    get currentTree(): Tree | null;
}
