import _createClass from "@babel/runtime/helpers/createClass";
import { isLocationChildrenDetail } from '@alilc/lowcode-utils';
import { Tree } from './tree';
export var TreeMaster = /*#__PURE__*/function () {
  function TreeMaster(pluginContext) {
    var _canvas$dragon,
      _this = this,
      _canvas$activeTracker,
      _canvas$dragon2;
    this.pluginContext = void 0;
    this.boards = new Set();
    this.treeMap = new Map();
    this.pluginContext = pluginContext;
    var startTime;
    var _this$pluginContext = this.pluginContext,
      event = _this$pluginContext.event,
      project = _this$pluginContext.project,
      canvas = _this$pluginContext.canvas;
    (_canvas$dragon = canvas.dragon) === null || _canvas$dragon === void 0 ? void 0 : _canvas$dragon.onDragstart(function () {
      startTime = Date.now() / 1000;
      // needs?
      _this.toVision();
    });
    (_canvas$activeTracker = canvas.activeTracker) === null || _canvas$activeTracker === void 0 ? void 0 : _canvas$activeTracker.onChange(function (target) {
      var node = target.node,
        detail = target.detail;
      var tree = _this.currentTree;
      if (!tree /* || node.document !== tree.document */) {
        return;
      }
      var treeNode = tree.getTreeNode(node);
      if (detail && isLocationChildrenDetail(detail)) {
        treeNode.expand(true);
      } else {
        treeNode.expandParents();
      }
      _this.boards.forEach(function (board) {
        board.scrollToNode(treeNode, detail);
      });
    });
    (_canvas$dragon2 = canvas.dragon) === null || _canvas$dragon2 === void 0 ? void 0 : _canvas$dragon2.onDragend(function () {
      var _project$currentDocum, _project$currentDocum2;
      var endTime = Date.now() / 1000;
      var nodes = (_project$currentDocum = project.currentDocument) === null || _project$currentDocum === void 0 ? void 0 : (_project$currentDocum2 = _project$currentDocum.selection) === null || _project$currentDocum2 === void 0 ? void 0 : _project$currentDocum2.getNodes();
      event.emit('outlinePane.dragend', {
        selected: nodes === null || nodes === void 0 ? void 0 : nodes.map(function (n) {
          var _n$componentMeta, _n$componentMeta2;
          if (!n) {
            return;
          }
          var npm = n === null || n === void 0 ? void 0 : (_n$componentMeta = n.componentMeta) === null || _n$componentMeta === void 0 ? void 0 : _n$componentMeta.npm;
          return [npm === null || npm === void 0 ? void 0 : npm["package"], npm === null || npm === void 0 ? void 0 : npm.componentName].filter(function (item) {
            return !!item;
          }).join('-') || (n === null || n === void 0 ? void 0 : (_n$componentMeta2 = n.componentMeta) === null || _n$componentMeta2 === void 0 ? void 0 : _n$componentMeta2.componentName);
        }).join('&'),
        time: (endTime - startTime).toFixed(2)
      });
    });
    project.onRemoveDocument(function (data) {
      var id = data.id;
      _this.treeMap["delete"](id);
    });
  }
  var _proto = TreeMaster.prototype;
  _proto.toVision = function toVision() {
    var tree = this.currentTree;
    if (tree) {
      var _this$pluginContext$p;
      var selection = (_this$pluginContext$p = this.pluginContext.project.getCurrentDocument()) === null || _this$pluginContext$p === void 0 ? void 0 : _this$pluginContext$p.selection;
      selection === null || selection === void 0 ? void 0 : selection.getTopNodes().forEach(function (node) {
        tree.getTreeNode(node).setExpanded(false);
      });
    }
  };
  _proto.addBoard = function addBoard(board) {
    this.boards.add(board);
  };
  _proto.removeBoard = function removeBoard(board) {
    this.boards["delete"](board);
  };
  _proto.purge = function purge() {
    // todo others purge
  };
  _createClass(TreeMaster, [{
    key: "currentTree",
    get: function get() {
      var doc = this.pluginContext.project.getCurrentDocument();
      if (doc) {
        var id = doc.id;
        if (this.treeMap.has(id)) {
          return this.treeMap.get(id);
        }
        var tree = new Tree(this.pluginContext);
        this.treeMap.set(id, tree);
        return tree;
      }
      return null;
    }
  }]);
  return TreeMaster;
}();