import TreeNode from './tree-node';
import { IPublicModelNode, IPublicModelPluginContext } from '@alilc/lowcode-types';
export declare class Tree {
    private treeNodesMap;
    readonly id: string | undefined;
    readonly pluginContext: IPublicModelPluginContext;
    get root(): TreeNode | null;
    constructor(pluginContext: IPublicModelPluginContext);
    setNodeSelected(nodeId: string): void;
    getTreeNode(node: IPublicModelNode): TreeNode;
    getTreeNodeById(id: string): TreeNode;
    expandAllAncestors(treeNode: TreeNode | undefined | null): void;
    expandAllDecendants(treeNode: TreeNode | undefined | null): void;
    collapseAllDecendants(treeNode: TreeNode | undefined | null): void;
}
