import { PureComponent } from 'react';
import TreeNode from '../controllers/tree-node';
import { IPublicModelPluginContext, IPublicTypeDisposable } from '@alilc/lowcode-types';
export default class TreeNodeView extends PureComponent<{
    treeNode: TreeNode;
    isModal?: boolean;
    pluginContext: IPublicModelPluginContext;
    isRootNode?: boolean;
}> {
    state: {
        expanded: boolean;
        selected: boolean;
        hidden: boolean;
        locked: boolean;
        detecting: boolean;
        isRoot: boolean;
        highlight: boolean;
        dropping: boolean;
        conditionFlow: boolean;
        expandable: boolean;
        treeChildren: TreeNode[] | null;
    };
    eventOffCallbacks: Array<IPublicTypeDisposable | undefined>;
    constructor(props: any);
    componentDidMount(): void;
    componentWillUnmount(): void;
    shouldShowModalTreeNode(): boolean;
    render(): JSX.Element;
}
